#include <bits/stdc++.h>

#define MAX (200000 + 1)

typedef long long ll;

using namespace std;

struct color{
    ll cid;
    ll cnt;
    color(ll _cid, ll _cnt){
        cid = _cid;
        cnt = _cnt;
    }
    bool operator<(const color& a) const {
        return cnt < a.cnt || (cnt == a.cnt && cid < a.cid);
    }
};

bool comp(color a, color b){
    return a.cnt > b.cnt || (a.cnt == b.cnt && a.cid > b.cid);
}

ll colors[MAX];
vector<color> sorted;
vector<ll> top;
vector<ll> bot;
ll mid;
priority_queue<color> top_construct;

void solve(){
    ll n, k, g;
    cin >> n >> k >> g;
    for(ll i = 0; i < n; i++){
        ll tmp;
        cin >> tmp;
        colors[tmp]++;
    }
    if(k == 1){
        cout << -1 << endl;
        return;
    }
    for(ll i = 1; i <= k; i++){
        sorted.push_back({i, colors[i]});
    }
    sort(sorted.begin(), sorted.end(), comp);
    ll left = 0;
    ll right = k - 1;
    mid = sorted[right].cid;
    if(sorted[right].cnt == 1)
        right--;
    else
        sorted[right].cnt--;
    bot.push_back(sorted[left].cid);
    sorted[left].cnt--;
    if(sorted[left].cnt == 0)
        left++;
    if(sorted.size() > 1){
        bot.push_back(sorted[1].cid);
        sorted[1].cnt--;
    }else{
        cout << -1 << endl;
        return;
    }
    if(bot.back() == mid){
        bot.push_back(sorted[left].cid);
        sorted[left].cnt--;
    }
    while(left < sorted.size() && sorted[left].cnt == 0)
        left++;
    while(right >= 0 && sorted[right].cnt == 0)
        right--;
    if(left == right){
        cout << -1 << endl;
        return;
    }
    for(ll i = left; i <= right; i++){
        top_construct.push(sorted[i]);
    }
    while(top_construct.size() > 1){
        color c1 = top_construct.top();
        top_construct.pop();
        color c2 = top_construct.top();
        top_construct.pop();
        if(!top.empty() && c1.cid == top.back()){
            swap(c1, c2);
        }
        top.push_back(c1.cid);
        top.push_back(c2.cid);
        c1.cnt--;
        c2.cnt--;
        if(c1.cnt > 0){
            top_construct.push(c1);
        }
        if(c2.cnt > 0){
            top_construct.push(c2);
        }
    }
    if(top_construct.empty()){
        if(top[top.size() - 1] == mid){
            if(top.size() == 2){
                cout << -1 << endl;
                return;
            }else if(top[top.size() - 1] != top[top.size() - 3]){
                swap(top[top.size() - 1], top[top.size() - 2]);
            }else{
                cout << -1 << endl;
                return;
            }
        }
    }else{
        color rest = top_construct.top();
        if(rest.cnt > 1){
            cout << -1 << endl;
            return;
        }else{
            top.push_back(rest.cid);
        }
    }
    cout << top.size() << " " << bot.size() << endl;
    for(ll i = 0; i < top.size(); i++){
        cout << top[i] << " ";
    }
    cout << endl << mid << endl;
    for(ll i = 0; i < bot.size(); i++){
        cout << bot[i] << " ";
    }
    cout << endl;
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    solve();
    return 0;
}
