#include <bits/stdc++.h>

#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;


const int N = 5 * 1e5 + 11;
int p[N], sz[N], np[101][101], nsz[101][101];
tree < int , null_type , less < int > , rb_tree_tag , tree_order_statistics_node_update > ost[N], nost[101][101];

int nfndp (int x, int i) {
    if (np[i][x] == x) return x;
    return np[i][x] = nfndp (np[i][x], i);
}

void nunite (int a, int b, int i) {
    a = nfndp (a, i);
    b = nfndp (b, i);
    if (a == b) return ;
    if (nsz[i][a] < nsz[i][b])
        swap (a, b);
    np[i][b] = a;
    nsz[i][a] += nsz[i][b];
    for (int ii : nost[i][b])
        nost[i][a].insert (ii);
    return ;
}

int fndp (int x) {
    if (p[x] == x) return x;
    return p[x] = fndp (p[x]);
}

void unite (int a, int b) {
    a = fndp (a);
    b = fndp (b);
    if (a == b) return ;
    if (sz[a] < sz[b])
        swap (a, b);
    p[b] = a;
    sz[a] += sz[b];
    for (int i : ost[b])
        ost[a].insert (i);
    return ;
}

int main()
{
    ios_base::sync_with_stdio(0);cin.tie(0);cout.tie(0);
    int n, q, g;
    cin >> n >> q >> g;
    for (int i = 1; i <= n; ++i) {
        sz[i] = 1, p[i] = i;
        ost[i].insert (i);
    }
    if (g == 1 || g == 2 || g == 4 || g == 5) {
        while (q--) {
            int t, v, u;
            cin >> t >> v >> u;
            if (t == 3) return 3;
            if (t == 1) {
                v = fndp (v);
                if (ost[v].size() >= u) cout << *(ost[v].find_by_order (u - 1)) << "\n";
                else cout << "-1\n";
            }
            else
                unite (v, u);
        }
    }
    if (g == 3 || g == 0) {
        for (int i = 1; i <= n; ++i) {
            nost[0][i].insert (i);
            np[0][i] = i;
            nsz[0][i] = 1;
        }
        for (int i = 1; i <= q; ++i) {
            for (int j = 1; j <= n; ++j) {
                nost[i][j] = nost[i - 1][j];
                np[i][j] = np[i - 1][j];
                nsz[i][j] = np[i - 1][j];
            }
            int t, v, u;
            cin >> t >> v ;
            if (t == 3) {
                int x = v;
                for (int j = 1; j <= n; ++j) {
                    nost[i][j] = nost[x][j];
                    np[i][j] = np[x][j];
                    nsz[i][j] = np[x][j];
                }
            }
            else if (t == 1) {
                cin >> u;
                v = nfndp (v, i);
                if (nost[i][v].size() >= u) cout << *(nost[i][v].find_by_order (u - 1)) << "\n";
                else cout << "-1\n";
            }
            else {
                cin >> u;
                nunite (v, u, i);
            }

        }
    }
    return 0;
}
