def main():
  n, q, g = map(int, input().split())

  graph = [[False] * (n + 1) for _ in range(n + 1)]

  history = []
  out = []

  for _ in range(q):
    inp = list(map(int, input().split()))

    if len(inp) == 3:
      if inp[0] == 1:
        vert = inp[1]
        k = inp[2] - 1

        out.append(k_lowest_vert(graph, vert, k))
        history.append(False)
      else:
        vert1 = inp[1]
        vert2 = inp[2]

        connect_vertices(graph, vert1, vert2)
        history.append((vert1, vert2))
    else:
      revert_to(graph, history, inp[1])
  
  for response in out:
    print(response)

def revert_to(graph, history, x):
  for action in range(x, len(history)):
    verts = history[action]

    if verts:
      disconnect_vertices(graph, verts[0], verts[1])

def k_lowest_vert(graph, vert, k):
  all_verts = componenta(graph, vert)

  if k >= len(all_verts):
    return -1
  
  return sorted(list(all_verts))[k]

def componenta(graph, vert):
  visited = {vert}

  edges_to_visit = edges_to_travel(graph, vert)

  while edges_to_visit:
    cur_vert = edges_to_visit.pop()

    if cur_vert in visited:
      continue
    
    edges_to_visit.extend(edges_to_travel(graph, cur_vert))
    visited.add(cur_vert)
  
  return visited


def edges_to_travel(graph, vert):
  return [i for (i, edge) in enumerate(graph[vert]) if edge]

def connect_vertices(graph, vert1, vert2):
  graph[vert1][vert2] = True
  graph[vert2][vert1] = True

def disconnect_vertices(graph, vert1, vert2):
  graph[vert1][vert2] = False
  graph[vert2][vert1] = False

def print_graph(graph):
  for row in graph:
    print(row)

if __name__ == "__main__":
  main()
