def main():
  n, q, g = map(int, input().split())

  graph = [dict() for _ in range(n + 1)]

  def revert_to(history, x):
    for action in range(x, len(history)):
      verts = history[action]

      if verts:
        disconnect_vertices(verts[0], verts[1])

  def k_lowest_vert(vert, k):
    all_verts = componenta(vert)

    if k >= len(all_verts):
      return -1
    
    return sorted(list(all_verts))[k]

  def componenta(vert):
    visited = {vert}

    edges_to_visit = edges_to_travel(vert)

    while edges_to_visit:
      cur_vert = edges_to_visit.pop()

      if cur_vert in visited:
        continue
      
      edges_to_visit.extend(edges_to_travel(cur_vert))
      visited.add(cur_vert)
    
    return visited

  def edges_to_travel(vert):
    return list(graph[vert].keys())

  def connect_vertices(vert1, vert2):
    graph[vert1][vert2] = True
    graph[vert2][vert1] = True

  def disconnect_vertices(vert1, vert2):
    graph[vert1].pop(vert2, None)
    graph[vert2].pop(vert1, None)

  def print_graph():
    for row in graph:
      print(row)

  history = []
  out = []

  for _ in range(q):
    inp = list(map(int, input().split()))

    if len(inp) == 3:
      if inp[0] == 1:
        vert = inp[1]
        k = inp[2] - 1

        out.append(k_lowest_vert(vert, k))
        history.append(False)
      else:
        vert1 = inp[1]
        vert2 = inp[2]

        connect_vertices(vert1, vert2)
        history.append((vert1, vert2))
    else:
      revert_to(history, inp[1])
  
  for response in out:
    print(response)

if __name__ == "__main__":
  main()
