//#pragma GCC target("Ofast, unroll-loops")
//#pragma GCC optimize("avx, avx2, tune=native")

#include <iostream>
#include <cmath>
#include <vector>
#include <set>
#include <map>
#include <algorithm>
#include <numeric>
#include <iomanip>
#include <queue>
#include <cassert>
#include <bitset>

using namespace std;

//#define int long long
#define fi first
#define se second

vector<vector<int>> par, rang;
vector<vector<vector<int>>> ans;

vector<int> merge(vector<int>& a, vector<int>& b)
{
	int l = 0, r = 0;
	vector<int> ans(a.size() + b.size());
	while (l < a.size() && r < b.size())
	{
		if (a[l] < b[r])
		{
			ans[l + r] = a[l];
			++l;
		}
		else
		{
			ans[l + r] = b[r];
			++r;
		}
	}
	if (l == a.size())
	{
		for (int i = r; i < b.size(); ++i) ans[i + l] = b[i];
	}
	else if (r == b.size())
	{
		for (int i = l; i < a.size(); ++i) ans[i + r] = a[i];
	}
	return ans;
}

int find_par(int v, int num)
{
	if (par[num][v] == v) return v;
	return par[num][v] = find_par(par[num][v], num);
}

void unite(int a, int b, int num)
{
	a = find_par(a, num);
	b = find_par(b, num);
	if (a != b)
	{
		if (rang[num][b] > rang[num][a]) swap(a, b);
		rang[num + 1] = rang[num];
		rang[num + 1][a] += rang[num][b];
		par[num + 1] = par[num];
		par[num + 1][b] = a;
		ans[num + 1] = ans[num];
		ans[num + 1][a] = merge(ans[num][b], ans[num][a]);
	}
	else
	{
		rang[num + 1] = rang[num];
		par[num + 1] = par[num];
		ans[num + 1] = ans[num];
	}
}

int getAns(int a, int k, int num)
{
	rang[num + 1] = rang[num];
	par[num + 1] = par[num];
	ans[num + 1] = ans[num];
	a = find_par(a, num);
	if (ans[num][a].size() < k) return -1;
	return ans[num][a][k - 1] + 1;
}

void duble(int x, int num)
{
	rang[num + 1] = rang[x];
	par[num + 1] = par[x];
	ans[num + 1] = ans[x];
}

int find_par4(int v)
{
	if (par[0][v] == v) return v;
	return par[0][v] = find_par4(par[0][v]);
}

void unite4(int a, int b)
{
	a = find_par4(a);
	b = find_par4(b);
	if (a != b)
	{
		if (rang[0][b] > rang[0][a]) swap(a, b);
		rang[0][a] += rang[0][b];
		par[0][b] = a;
		ans[0][a] = merge(ans[0][b], ans[0][a]);
	}
}

int getAns4(int a, int k)
{
	a = find_par4(a);
	if (ans[0][a].size() < k) return -1;
	return ans[0][a][k - 1] + 1;
}


signed main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	int n, q, g, type, c1, c2;
	cin >> n >> q >> g;
	if (g < 4)
	{
		par.resize(q + 1, vector<int>(n));
		for (int i = 0; i < n; ++i)
		{
			par[0][i] = i;
		}
		rang.resize(q + 1, vector<int>(n));
		for (int i = 0; i < n; ++i)
		{
			rang[0][i] = 1;
		}
		ans.resize(q + 1, vector<vector<int>>(n));
		for (int i = 0; i < n; ++i)
		{
			ans[0][i].push_back(i);
		}
		for (int i = 0; i < q; ++i)
		{
			cin >> type;
			if (type == 1)
			{
				cin >> c1 >> c2;
				--c1;
				cout << getAns(c1, c2, i) << '\n';
			}
			else if (type == 2)
			{
				cin >> c1 >> c2;
				--c1;
				--c2;
				unite(c1, c2, i);
			}
			else
			{
				cin >> c1;
				duble(c1, i);
			}
		}
		return 0;
	}
	par.resize(1, vector<int>(n));
	for (int i = 0; i < n; ++i) par[0][i] = i;
	rang.resize(1, vector<int>(n));
	for (int i = 0; i < n; ++i) rang[0][i] = 1;
	ans.resize(1, vector<vector<int>>(n));
	for (int i = 0; i < n; ++i) ans[0][i].push_back(i);
	for (int i = 0; i < q; ++i)
	{
		cin >> type;
		if (type == 1)
		{
			cin >> c1 >> c2;
			--c1;
			cout << getAns4(c1, c2) << '\n';
		}
		else if (type == 2)
		{
			cin >> c1 >> c2;
			--c1;
			--c2;
			unite4(c1, c2);
		}
		else
		{
			cin >> c1;
		}
	}
	return 0;
}

/*

*/