using System;
using System.Linq;
using System.Collections.Generic;

class Solution
{
    static int BinarySearch(int[] array, int val)
    {
        int min = 0;
        int max = array.Length - 1;

        while (min <= max)
        {
            int middle = (min + max) / 2;
            if (val == array[middle])
            {
                return middle + 1;
            }
            else if (val < array[middle])
            {
                max = middle - 1;
            }
            else
            {
                min = middle + 1;
            }
        }

        return -1;
    }

    public static void Main()
    {
        string[] input = Console.ReadLine()!.Split();
        int n = int.Parse(input[0]);
        int m = int.Parse(input[1]);
        int g = int.Parse(input[2]);

        int edge_sum = 0;
        int[,] edges = new int[n, n];
        List<int>[] connections = new List<int>[n];
        for (int i = 0; i < n; i++)
        {
            connections[i] = new List<int>();
        }

        for (int i = 0; i < n - 1; i++)
        {
            input = Console.ReadLine()!.Split();
            int u = int.Parse(input[0]);
            int v = int.Parse(input[1]);
            int c = int.Parse(input[2]);

            connections[u - 1].Add(v - 1);
            connections[v - 1].Add(u - 1);
            edges[u - 1, v - 1] = c;
            edges[v - 1, u - 1] = c;
            edge_sum += c;
        }

        int[] k_arr = new int[m];
        int[] result = new int[m];
        input = Console.ReadLine()!.Split();
        for (int i = 0; i < m; i++)
        {
            k_arr[i] = int.Parse(input[i]);
        }

        int[] k_sorted_indexes = Enumerable.Range(0, m).ToArray();
        Array.Sort(k_sorted_indexes, (a, b) => k_arr[a].CompareTo(k_arr[b]));
        switch (g)
        {
            case 0:
            case 1:
            case 2:
            case 3:
            case 4:
            case 5:
            case 6:

                int[] vertex_values = new int[n];
                for (int v = 0; v < n; v++)
                {
                    foreach (int u in connections[v])
                    {
                        vertex_values[v] += edges[v, u];
                    }
                }

                int max_vertex;
                int max_vertex_index;
                List<int> limits = new() { edge_sum };
                
                while (edge_sum > k_arr[k_sorted_indexes[0]])
                {
                    max_vertex = vertex_values.Max();
                    max_vertex_index = Array.IndexOf(vertex_values, max_vertex);

                    edge_sum -= max_vertex;
                    vertex_values[max_vertex_index] = 0;
                    foreach (int v in connections[max_vertex_index])
                    {
                        connections[v].Remove(max_vertex_index);
                        vertex_values[v] -= max_vertex;
                    }
                    limits.Add(edge_sum);
                }

                limits.Reverse();
                Array.Sort(k_arr);

                int limit_index;
                int last_limit_index = 0;
                for (int i = 0; i < limits.Count; i++)
                {
                    limit_index = BinarySearch(k_arr, limits[i]) - 1;
                    for (int j = last_limit_index; j < limit_index; j++)
                    {
                        result[k_sorted_indexes[j]] = i;
                    }
                    last_limit_index = limit_index;
                }

                break;

            default:
                break;
        }

        Console.WriteLine(string.Join(" ", result));
    }
}