#include <iostream>
#include <vector>
#include <climits>

using namespace std;

class Node;

vector<Node*> nodes;

class Conn {
public:
	Node* start;
	Node* end;
	int weight;
	Conn(Node* start, Node* end, int w) : start(start), end(end), weight(w) {}
};

class Node {
public:
	vector<Conn*> child;
	Conn* parrent = nullptr;
	int index;
};

int minimize(vector<Conn*>& conns, int max) {
	int w = 0;
	for (int i = 0; i < conns.size(); i++) {
		w += conns[i]->weight;
	}

	if (w <= max)
		return 0;

	int acts = 0;
	vector<Node*> turn_on = nodes;

	while (w > max) {
		Conn* some = new Conn(nullptr, nullptr, INT_MIN);

		for (int i = 0; i < conns.size(); i++) {
			if (conns[i]->weight > some->weight) {
				some = conns[i];
			}
		}
		
		for (int i = 0; i < turn_on.size(); i++) {
			if (turn_on[i] == some->start)
				turn_on.erase(turn_on.begin() + i);
		}

		for (int i = 0; i < some->start->child.size(); i++) {
			w -= some->start->child[i]->weight;
		}

		acts++;
	}
	return acts;
}

int main() {
	int node_count, requests, _;
	cin >> node_count >> requests >> _;

	vector<Conn*> conns;
	vector<Node*> nodes;
	int* req = new int[requests];

	for (int i = 0; i < node_count; i++) {
		Node* n = new Node();
		n->index = i;
		nodes.push_back(n);
	}

	for (int i = 0; i < node_count - 1; i++) {
		int start, end, weight;
		cin >> start >> end >> weight;

		Node* sn = nodes[start - 1];
		Node* en = nodes[end - 1];
		if (sn->index > en->index)
			swap(sn, en);

		Conn* con = new Conn(sn, en, weight);
		en->parrent = con;
		sn->child.push_back(con);
		conns.push_back(con);
	}

	for (int i = 0; i < requests; i++) {
		cin >> req[i];
	}

	for (int i = 0; i < requests; i++) {
		cout << minimize(conns, req[i]);
	}

	return 0;
}