#include <algorithm>
#include <vector>
#include <string>
#include <iostream>
#include <map>
#include <cmath>
#include <climits>
#include <set>

using namespace std;

vector<vector<int>> ways;
vector<vector<int>> comp;
vector<int> myid;

struct stan 
{
    vector<vector<int>> ways;
    vector<vector<int>> comp;
    vector<int> myid;
};

vector<stan> stans;

stan getstan(vector<vector<int>> ws, vector<vector<int>> cp, vector<int> md)
{
    stan res;
    res.ways = ws;
    res.comp = cp;
    res.myid = md;
    return res;
}


int main()
{
    int n, q, g;
    cin >> n >> q >> g;
    ways = vector<vector<int>>(n);
    comp = vector<vector<int>>(n);
    for (int i = 0; i < n; i++)
    {
        myid.push_back(i);
        comp[i].push_back(i);
    }

    for (int i = 0; i < q; i++)
    {
        stans.push_back(getstan(ways, comp, myid));
        int t;
        cin >> t;
        if (t == 1)
        {
            int vi, ki;
            cin >> vi >> ki;
            vi--;
            if (comp[myid[vi]].size() > ki-1)
            {
                cout << comp[myid[vi]][ki-1]+1 << "\n";
            }
            else cout << -1 << "\n";
        }
        if (t == 2)
        {
            int ai, bi;
            cin >> ai >> bi;
            ai--;
            bi--;
            if (myid[ai] != myid[bi]) 
            {
                if (comp[myid[ai]].size() < comp[myid[bi]].size())
                {
                    int r = ai;
                    ai = bi;
                    bi = r;
                }
                int inid = myid[bi];
                for (int i = 0; i < comp[inid].size(); i++)
                {
                    int ind = comp[inid][i];
                    myid[ind] = myid[ai];
                    comp[myid[ai]].push_back(ind);
                }
                sort(comp[myid[ai]].begin(), comp[myid[ai]].end());
            }
        }
        if (t == 3)
        {
            int xi;
            cin >> xi;
            xi;
            ways = stans[xi].ways;
            comp = stans[xi].comp;
            myid = stans[xi].myid;
        }
    }
}
