#include <algorithm>
#include <vector>
#include <string>
#include <iostream>
#include <map>
#include <cmath>
#include <climits>
#include <set>
#include <queue>

using namespace std;

vector<vector<int>> ways;
vector<vector<int>> comp;
vector<int> myid;

struct stan 
{
    vector<vector<int>> ways;
    vector<vector<int>> comp;
    vector<int> myid;
};

vector<stan> stans;

stan getstan(vector<vector<int>> ws, vector<vector<int>> cp, vector<int> md)
{
    stan res;
    res.ways = ws;
    res.comp = cp;
    res.myid = md;
    return res;
}

int kthel(vector<int> const& input, int k)
{
    priority_queue<int, vector<int>> prqueue(input.begin(), input.begin() + k);

    for (int i = k; i < input.size(); i++)
    {
        if (input[i] < prqueue.top())
        {
            prqueue.pop();
            prqueue.push(input[i]);
        }
    }
    return prqueue.top();
}

int main()
{
        ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    int n, q, g;
    cin >> n >> q >> g;
    bool act = true;
    if (g == 4)act = false;
    ways = vector<vector<int>>(n);
    comp = vector<vector<int>>(n);
    for (int i = 0; i < n; i++)
    {
        myid.push_back(i);
        comp[i].push_back(i);
    }

    for (int i = 0; i < q; i++)
    {
        if (act)stans.push_back(getstan(ways, comp, myid));
        int t;
        cin >> t;
        if (t == 1)
        {
            int vi, ki;
            cin >> vi >> ki;
            vi--;
            if (comp[myid[vi]].size() > ki-1)
            {
                cout << kthel(comp[myid[vi]], ki)+1 << "\n";
            }
            else cout << -1 << "\n";
        }
        if (t == 2)
        {
            int ai, bi;
            cin >> ai >> bi;
            ai--;
            bi--;
            if (myid[ai] != myid[bi]) 
            {
                int inid = myid[bi];
                for (int i = 0; i < comp[inid].size(); i++)
                {
                    int ind = comp[inid][i];
                    myid[ind] = myid[ai];
                    comp[myid[ai]].push_back(ind);
                }
            }
        }
        if (t == 3)
        {
            int xi;
            cin >> xi;
            xi;
            ways = stans[xi].ways;
            comp = stans[xi].comp;
            myid = stans[xi].myid;
        }
    }
}