#include <queue>
#include <vector>
#include <map>
#include <iostream>

using namespace std;

vector<int> _arr_with_answer;

void sort_f(vector<int> vect, int n)
{
    map<int, int> frequencies;
    map<int, bool> visited;
    vector<int> result(n);

    for(int i = 0; i < n; i++)
    {
        frequencies[vect[i]]++;
    }
     
    priority_queue<pair<int, int>> q;
     
    for(int i = 0; i < n ; i++)
    {
        int value = vect[i];
        if (frequencies[value] > 0 && !visited[value])
        {
            q.push({frequencies[value], value});
        }
        visited[value] = true;
    }
     
    pair<int, int> prev = {-1, -1};
    int i = 0;
     
    while (q.size() != 0)
    {
        pair<int,int> k = q.top();
        q.pop();
        result[i] = k.second;
         
        if (prev.first > 0)
        {
            q.push(prev);
        }
         
        --k.first;
        prev = k;
        ++i;
    }
     
    for(auto x : result)
    {
        if (x == 0)
        {
            cout << -1 << "\n";
            return;
        }
    }
     
    _arr_with_answer = result;
}

int main()
{
    vector<int> v;
    int n, k, g, h, middle_element;
    cin >> n >> k >> g;
    for(int i = 0; i < n; i++) {
        cin >> h;
        v.push_back(h);
    }
    sort_f(v, n);
    if(_arr_with_answer.size() == 0)
        return 0;
    h = -1;
    for(int i = 2; i < _arr_with_answer.size() - 2; i++) {
        if(_arr_with_answer[i] != _arr_with_answer[i - 1] && _arr_with_answer[i] != _arr_with_answer[i + 1] && _arr_with_answer[i] != _arr_with_answer[0] && _arr_with_answer[i] != _arr_with_answer[_arr_with_answer.size() - 1]) {
            h = _arr_with_answer[i];
            middle_element = i;
            break;
        }
    }

    if(h == -1) {
        cout << -1 << "\n";
        return 0;
    }

    cout << middle_element << " " << _arr_with_answer.size() - middle_element -1 << "\n";

    for(int i = 0; i < middle_element; i++) {
        cout << _arr_with_answer[i] << " ";
    }
    cout << "\n" << h << "\n";
    for(int i = middle_element + 1; i < _arr_with_answer.size(); i++) {
        cout << _arr_with_answer[i] << " ";
    }
    cout << "\n";
}