#include <iostream>
#include <cmath>
#include <algorithm>
#include <string>
#include <vector>
#include <set>
#include <numeric>
#include <map>
#include <queue>
#include <cassert>

using namespace std;

using ll = long long;

struct Edge
{
    bool del = false;
    int a, b;
    int w;
};

int main()
{
    cin.tie(0)->sync_with_stdio(0);
    int n, m, g;
    cin >> n >> m >> g;
    vector<Edge> edges(n - 1);
    int allw = 0;
    for (auto &i : edges)
    {
        cin >> i.a >> i.b >> i.w;
        allw += i.w;
    }
    vector<pair<int, int>> queries(m);
    for (int i = 0; i < m; ++i)
    {
        cin >> queries[i].first;
        queries[i].second = i;
    }
    vector<int> res(m);
    sort(queries.begin(), queries.end(), greater<>());
    int counter = 0;
    for (int i = 0; i < m; ++i)
    {
        while (allw > queries[i].first)
        {
            vector<int> checker(n + 1);
            for (Edge i : edges)
            {
                if (!i.del)
                {
                    checker[i.a] += i.w;
                    checker[i.b] += i.w;
                }
            }
            int ind = 1;
            for (int i = 1; i <= n; ++i)
            {
                if (checker[i] > checker[ind])
                {
                    ind = i;
                }
            }
            allw -= checker[ind];
            ++counter;
            for (Edge &i : edges)
            {
                if (i.a == ind || i.b == ind) i.del = true;
            }
        }
        res[queries[i].second] = counter;
    }
    for (int i : res) cout << i << ' ';
    return 0;
}
