#include <iostream>
#include <cmath>
#include <algorithm>
#include <string>
#include <vector>
#include <set>
#include <numeric>
#include <map>
#include <queue>
#include <cassert>

using namespace std;

using ll = long long;

struct Edge
{
    bool del = false;
    int a, b;
    int w;
};

void dfs(int v, int p, int pe, vector<vector<pair<int, int>>> &adj, vector<vector<int>> &dp0, vector<vector<int>> &dp1)
{
    int n = (int)adj.size() - 1;
    dp1[v] = vector<int>(n + 1, pe);
    dp1[v][0] = 0;
    for (auto [u, w] : adj[v])
    {
        if (u == p) continue;
        dfs(u, v, w, adj, dp0, dp1);
        for (int i = 0; i <= n; ++i)
        {
            dp0[v][i] += max(dp0[u][i], dp1[u][i]);
            if (i > 0) dp1[v][i] += max(dp0[u][i - 1] + w, dp1[u][i - 1]);
        }
    }
}

int main()
{
    cin.tie(0)->sync_with_stdio(0);
    int n, m, g;
    cin >> n >> m >> g;
    vector<vector<pair<int, int>>> adj(n + 1);
    int all = 0;
    for (int i = 0; i + 1 < n; ++i)
    {
        int u, v, w;
        cin >> u >> v >> w;
        adj[u].emplace_back(v, w);
        adj[v].emplace_back(u, w);
        all += w;
    }
    vector<vector<int>> dp0(n + 1, vector<int>(n + 1)), dp1(n + 1, vector<int>(n + 1));
    dfs(1, 0, 0, adj, dp0, dp1);
    vector<int> res(n + 1);
    for (int i = 0; i < n; ++i) res[i] = max(dp0[1][i], dp1[1][i]);
    while (m--)
    {
        int k;
        cin >> k;
        //find first >= all - k
        auto it = lower_bound(res.begin(), res.end(), all - k);
        cout << distance(res.begin(), it) << ' ';
    }
    /*vector<Edge> edges(n - 1);
    int allw = 0;
    for (auto &i : edges)
    {
        cin >> i.a >> i.b >> i.w;
        allw += i.w;
    }
    vector<pair<int, int>> queries(m);
    for (int i = 0; i < m; ++i)
    {
        cin >> queries[i].first;
        queries[i].second = i;
    }
    if (g == 4)
    {
        for (auto &i : edges)
        {
            --i.a;
            --i.b;
        }
        int minres = n;
        for (int i = 0; i < (1 << n); ++i)
        {
            int sum = 0;
            for (auto j : edges)
            {
                if (!(i & (1 << j.a)) && !(i & (1 << j.b))) sum += j.w;
            }
            int counter = 0;
            for (int j = 0; j < n; ++j) counter += (i >> j) & 1;
            if (sum <= queries.front().first)
            {
                minres = min(minres, counter);
            }
        }
        cout << minres;
        return 0;
    }
    if (g == 3)
    {
        
    }
    vector<int> res(m);
    sort(queries.begin(), queries.end(), greater<>());
    int counter = 0;
    for (int i = 0; i < m; ++i)
    {
        while (allw > queries[i].first)
        {
            vector<int> checker(n + 1);
            for (Edge i : edges)
            {
                if (!i.del)
                {
                    checker[i.a] += i.w;
                    checker[i.b] += i.w;
                }
            }
            int ind = 1;
            for (int i = 1; i <= n; ++i)
            {
                if (checker[i] >= checker[ind])
                {
                    ind = i;
                }
            }
            allw -= checker[ind];
            ++counter;
            for (Edge &i : edges)
            {
                if (i.a == ind || i.b == ind) i.del = true;
            }
        }
        res[queries[i].second] = counter;
    }
    for (int i : res) cout << i << ' ';*/
    return 0;
}
