#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

constexpr ll MAXN = 3000;

ll q, n, m, k, x, y, z, a, b, c, d, g;
vector< pair<ll, ll> > G[MAXN];
ll sum[MAXN];

struct dsu {
    vector<ll> par;
    vector<ll> sz;
    vector< vector<ll> > sorted;
    dsu() {}
    dsu(ll x) {
        par.resize(x);
        sz.resize(x);
        sorted.resize(x);
        for (int i = 0; i < x; i++) {
            par[i] = i;
            sz[i] = 1;
            sorted[i].push_back(i);
        }
    }
    ll find_p(ll x) {
        return (x == par[x] ? x : (par[x] = find_p(par[x])));
    }
    void join(ll x, ll y) {
        // cout << x << ' ' << y << endl;
        x = find_p(x);
        y = find_p(y);
        if (sz[x] < sz[y]) {
            swap(x, y);
        }
        if (x == y) {
            return;
        }
        // cout << x << ' ' << y << endl;
        // cout << sorted[x].size() << endl;
        // cout << sorted[y].size() << endl;
        for (int i = 0; i < sorted[y].size(); i++) {
            // cout << i << endl;
            sorted[x].push_back(sorted[y][i]);
        }
        // cout << "DEBUG" << endl;
        sort(sorted[x].begin(), sorted[x].end());
        // cout << sorted[x][0] << endl;
        sz[x] += sz[y];
        par[y] = x;
        sorted[y].clear();
    }
    ll order(ll x, ll k) {
        x = find_p(x);
        if (sz[x] < k) {
            return -1;
        }
        else {
            return sorted[x][k - 1] + 1;
        }
    }
};

struct dsu_r {
    vector<ll> par;
    vector<ll> sz;
    vector<ll> l, r;
    dsu_r() {}
    dsu_r(ll x) {
        par.resize(x);
        sz.resize(x);
        l.resize(x);
        r.resize(x);
        for (int i = 0; i < x; i++) {
            par[i] = i;
            sz[i] = 1;
            l[i] = i;
            r[i] = i;
        }
    }
    ll find_p(ll x) {
        return (x == par[x] ? x : (par[x] = find_p(par[x])));
    }
    void join(ll x, ll y) {
        // cout << x << ' ' << y << endl;
        x = find_p(x);
        y = find_p(y);
        if (sz[x] < sz[y]) {
            swap(x, y);
        }
        if (x == y) {
            return;
        }
        // cout << x << ' ' << y << endl;
        // cout << sorted[x].size() << endl;
        // cout << sorted[y].size() << endl;
        l[x] = min(l[x], l[y]);
        r[x] = max(r[x], r[y]);
        // cout << "DEBUG" << endl;
        // cout << sorted[x][0] << endl;
        sz[x] += sz[y];
        par[y] = x;
    }
    ll order(ll x, ll k) {
        x = find_p(x);
        if (sz[x] < k) {
            return -1;
        }
        else {
            return l[x] + k;
        }
    }
};

dsu ds[101];
dsu_r dsr[548];

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cin >> n >> q >> g;
//    cout << "DEBUG" << endl;
    vector<string> e(q);
    cin.ignore();
    for (int i = 0; i < q; i++) {
        getline(cin, e[i]);
    }
    if (g == 1) {
        for (int i = 0; i < q; i++) {
            stringstream s_(e[i]);
            ll temp;
            s_ >> temp;
            s_ >> x;
            s_ >> k;
            if (k > 1) {
                cout << -1 << '\n';
            }
            else {
                cout << x << '\n';
            }
        }
    }
    else if (g <= 3) {
        ds[0] = dsu(n);
        for (int i = 0; i < q; i++) {
            ds[i + 1] = ds[i];
            stringstream s_(e[i]);
            ll temp;
            s_ >> temp;
            if (temp == 1) {
                s_ >> x >> k;
                x--;
                // cout << "DEBUG1" << endl;
                cout << ds[i + 1].order(x, k) << '\n';
            }
            else if (temp == 2) {
                s_ >> x >> y;
                x--;
                y--;
                // cout << "DEBUG2" << endl;
                ds[i + 1].join(x, y);
            }
            else {
                s_ >> x;
                // cout << "DEBUG3" << endl;
                ds[i + 1] = ds[x];
            }
        }
    }
    else {
        dsr[0] = dsu_r(n);
        auto rr = &dsr[0];
        for (int i = 0; i < q; i++) {
            ll rt = i / 548;
            stringstream s_(e[i]);
            ll temp;
            s_ >> temp;
            if (temp == 1) {
                s_ >> x >> k;
                x--;
                // cout << "DEBUG1" << endl;
                cout << rr->order(x, k) << '\n';
            }
            else if (temp == 2) {
                s_ >> x >> y;
                x--;
                y--;
                // cout << "DEBUG2" << endl;
                rr->join(x, y);
            }
            else {
                s_ >> x;
                // cout << "DEBUG3" << endl;
                rr = &dsr[x / 548];
                for (int j = x / 548 * 548; j < x; j++) {
                    stringstream s_1(e[j]);
                    ll temp;
                    s_1 >> temp;
                    if (temp == 2) {
                        s_1 >> x >> y;
                        x--;
                        y--;
                        // cout << "DEBUG2" << endl;
                        rr->join(x, y);
                    }
                }
            }
            if (i % 548 == 0) {
                dsr[i] = *rr;
            }
        }
    }
}
