#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

using ordered_set = tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>;

const int N = 110;

struct DSU {
    int p[N];
    ordered_set l[N];

    void make_set(int i) {
        p[i] = i;
        l[i].insert(i);
    }

    int find_set(int i) {
        if (p[i] == i) {
            return i;
        }
        return p[i] = find_set(p[i]);
    }

    void union_set(int a, int b) {
        a = find_set(a);
        b = find_set(b);
        if (a == b) {
            return;
        }
        if (l[a].size() < l[b].size()) {
            swap(a, b);
        } // sz[a] >= sz[b]
        p[b] = a;
        for (auto i : l[b]) {
            l[a].insert(i);
        }
    }
};

DSU cop[N];

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, q, tt;
    cin >> n >> q >> tt;
    DSU curr;
    for (int i = 1; i <= n; ++i) {
        curr.make_set(i);
    }
    cop[0] = curr;
    for (int qq = 1; qq <= q; ++qq) {
        int type;
        cin >> type;
        if (type == 1) {
            int i, k;
            cin >> i >> k;
            --k;
            i = curr.find_set(i);
            if (k >= curr.l[i].size()) {
                cout << -1 << '\n';
            } else {
                cout << *curr.l[i].find_by_order(k) << '\n';
            }
        } else if (type == 2) {
            int u, v;
            cin >> u >> v;
            curr.union_set(u, v);
        } else {
            int x;
            cin >> x;
            curr = cop[x];
        }
        cop[qq] = curr;
    }
    return 0;
}