#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;
using ordered_set = tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>;

const int N = 1e5;

struct DSU {
    int p[N];
    ordered_set l[N];
    //vector<int> l[N];

    void make_set(int i) {
        p[i] = i;
        l[i].insert(i);
    }

    int find_set(int i) {
        if (p[i] == i) {
            return i;
        }
        return p[i] = find_set(p[i]);
    }

    void union_set(int a, int b) {
        a = find_set(a);
        b = find_set(b);
        if (a == b) {
            return;
        }
        if (l[a].size() < l[b].size()) {
            swap(a, b);
        } // sz[a] >= sz[b]
        p[b] = a;
        for (auto i : l[b]) {
            l[a].insert(i);
        }
    }
};

const int K = 700;

DSU b[N / K];

struct req {
    int type, a, b;
};

vector<req> r;

void doRollback(DSU& curr, int x) {
    curr = b[x / K];
    for (int j = x - x % K + 1; j <= x; ++j) {
        int type = r[j].type;
        if (type == 1) {
            continue;
        } else if (type == 2) {
            int u = r[j].a;
            int v = r[j].b;
            curr.union_set(u, v);
        } else if (type == 3) {
            int xx = r[j].a;
            doRollback(curr, xx);
        }
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, q, tt;
    cin >> n >> q >> tt;
    DSU curr;
    for (int i = 1; i <= n; ++i) {
        curr.make_set(i);
    }
    b[0] = curr;
    r.push_back({0, 0, 0});
    for (int qq = 1; qq <= q; ++qq) {
        int type;
        cin >> type;
        if (type == 1) {
            int i, k;
            cin >> i >> k;
            --k;
            r.push_back({type, i, k});
            i = curr.find_set(i);
            if (k >= curr.l[i].size()) {
                cout << -1 << '\n';
            } else {
                //nth_element(curr.l[i].begin(), curr.l[i].begin() + k, curr.l[i].end());
                //cout << curr.l[i][k] << '\n';
                cout << *curr.l[i].find_by_order(k) << '\n';
            }
        } else if (type == 2) {
            int u, v;
            cin >> u >> v;
            r.push_back({type, u, v});
            curr.union_set(u, v);
        } else {
            int x;
            cin >> x;
            r.push_back({type, x, -1});
            doRollback(curr, x);
        }
        if (qq % K == 0) {
            b[qq / K] = curr;
        }
    }
    return 0;
}