#include <cstdio>
#include <cassert>
#include <algorithm>
#include <vector>

struct engine {
	int *arr, size;
	int loe(int x) {
		return std::upper_bound(arr, arr + size, x) - arr;
	}
	engine() {}
	engine(int x) {
		arr = new int [1];
		size = 1;
		*arr = x;
	}
};

const int N = 500100;
int K = 50;
const int S = 2000000;
int n, m, G, type[N], x[N], y[N], top[N], size[N], ans[N], down[N], dep[N], ondep[N];
int esize;
engine *e[S];
std::vector<int> g[N], *go[S];

int find(int v) {
	while (top[v] != -1) v = top[v];
	return v;
}

int num;
void src(std::vector<int> &to, int v) {
	num += e[v]->size;
	to.push_back(v);
	for (int i = 0; i < (int)go[v]->size(); ++i) src(to, go[v]->at(i));
}

void dfs0(int v) {
	if (type[v] == 1) {
		down[v] = 1;
		++ondep[dep[v]];
	}
	for (int i = 0; i < (int)g[v].size(); ++i) {
		dep[g[v][i]] = dep[v] + 1;
		dfs0(g[v][i]);
		down[v] += down[g[v][i]];
	}
}

std::vector<int> all;

void mrg(int v, engine *&preveng, std::vector<int> *&prevgo) {
	preveng = e[x[v]];
	prevgo = go[x[v]];
	std::pair<int, int> mx;
	for (int i = 0; i < (int)all.size(); ++i) mx = std::max(mx, std::make_pair(e[all[i]]->size, i));
	engine *next = new engine;
	next->size = num - mx.first;
	next->arr = new int [next->size];
	for (int i = 0, j = 0; i < (int)all.size(); ++i) if (i != mx.second) 
		for (int k = 0; k < (int)e[all[i]]->size; ++k) 
			next->arr[j++] = e[all[i]]->arr[k];
	std::sort(next->arr, next->arr + next->size);
	e[esize] = e[all[mx.second]];
	e[x[v]] = next;
	go[x[v]] = new std::vector<int>();
	assert(esize < S);
	go[x[v]]->push_back(esize);
	go[esize] = new std::vector<int>();
	++esize;
}

void dfs(int v) {
	engine *preveng;
	std::vector<int> *prevgo;
	bool merge = 0;
	if (type[v] == 1) {
		all.clear();
		num = 0;
		x[v] = find(x[v]);
		src(all, x[v]);
		if (num <= y[v]) ans[v] = -1;
		else {
			int l = 0, r = n;
			while (l < r) {
				int m = l + r >> 1, cnt = 0;
				for (int i = 0; i < (int)all.size(); ++i) cnt += e[all[i]]->loe(m);
				if (cnt >= y[v] + 1) r = m;
				else l = m + 1;
			}
			ans[v] = r + 1;
		}
	} else if (type[v] == 2) {
		x[v] = find(x[v]);
		y[v] = find(y[v]);
		if (x[v] != y[v]) {
			if (size[x[v]] < size[y[v]]) std::swap(x[v], y[v]);
			size[x[v]] += size[y[v]];
			top[y[v]] = x[v];
			go[x[v]]->push_back(y[v]);
			if (down[v] >= 50) {
				all.clear();
				num = 0;
				src(all, x[v]);
				if (all.size() > K) {
					merge = 1;
					mrg(v, preveng, prevgo);
				}
			}
		}
	}
	for (int i = 0; i < (int)g[v].size(); ++i) dfs(g[v][i]);
	if (merge) {
		e[x[v]] = preveng;
		go[x[v]] = prevgo;
	}
	if (type[v] == 2 && x[v] != y[v]) {
		size[x[v]] -= size[y[v]];
		top[y[v]] = -1;
		go[x[v]]->pop_back();
	}
}

int main() {
	scanf("%d%d%d", &n, &m, &G);
	if (G == 5) K = 90;
	esize = n;
	for (int i = 0; i < n; ++i) {
		size[i] = 1;
		top[i] = -1;
		e[i] = new engine(i);
		go[i] = new std::vector<int>();
	}
	for (int i = 1; i <= m; ++i) {
		scanf("%d", type + i);
		if (type[i] == 1) {
			scanf("%d%d", x + i, y + i);
			--x[i];
			--y[i];
			g[i - 1].push_back(i);
		} else if (type[i] == 2) {
			scanf("%d%d", x + i, y + i);
			--x[i];
			--y[i];
			g[i - 1].push_back(i);
		} else {
			scanf("%d", x + i);
			g[x[i]].push_back(i);
		}
	}
	dfs0(0);
	dfs(0);
	for (int i = 1; i <= m; ++i) if (type[i] == 1) printf("%d\n", ans[i]);
	return 0;
}